package java.rmi.server;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;

public abstract class RMISocketFactory {
   private static RMISocketFactory factory = null;
   private static RMIFailureHandler handler = null;

   public abstract Socket createSocket(String var1, int var2) throws IOException;

   public abstract ServerSocket createServerSocket(int var1) throws IOException;

   public static void setSocketFactory(RMISocketFactory var0) throws IOException {
      if (factory != null) {
         throw new SocketException("factory already defined");
      } else {
         SecurityManager var1 = System.getSecurityManager();
         if (var1 != null) {
            var1.checkSetFactory();
         }

         factory = var0;
      }
   }

   public static RMISocketFactory getSocketFactory() {
      return factory;
   }

   public static void setFailureHandler(RMIFailureHandler var0) {
      handler = var0;
   }

   public static RMIFailureHandler getFailureHandler() {
      return handler;
   }
}
